#!/usr/bin/perl -I/usr/sausalito/perl
#
# $Id: generate_vps_graphs.pl
#
# Handler which writes / updates the user_beancounter RRD graphs.
#

use CCE;
use POSIX qw(isalpha);

my $DEBUG = 0;

my $cce = new CCE('Domain' => 'base-vserver');

$cce->connectfd();

($sys_oidmasternode) = $cce->find('VserverTraffic');
($ok, $VserverTraffic) = $cce->get($sys_oidmasternode);
$vpsid = $VserverTraffic->{generate_vps_graphs};

($sys_vserver) = $cce->find('Vserver', {'vpsid' => $vpsid});
($ok, $Vserver) = $cce->get($sys_vserver);
$last_graph = $Vserver->{last_graph};

$nowtime = time();

# Find if we need to update the graphics now or not:
if ($last_graph + 180 > $nowtime) {
    # Last update was less than 3 minutes ago. Do nothing now.
    $do_update = "1";

    # We need to say 'SUCCESS' or CCE will bitch:
    $cce->bye('SUCCESS');
    exit(0);
}

my $vserver = $cce->event_object();
my $vserver_new = $cce->event_new();
my $vserver_old = $cce->event_old();

if (($vserver_new->{generate_graphs_multi}) || ($vserver_new->{generate_vps_graphs})) {
    $rrd_file = "/usr/sausalito/ui/web/base/traffic/vpsimages/" . $vpsid . "/" . $vpsid . ".rrd";
    if ( ! -f $rrd_file) {
        system("/usr/sausalito/sbin/system_graphs.pl update");
    }
    system("/bin/chmod 644 $rrd_file");
    system("/usr/sausalito/sbin/system_graphs.pl graph daily $vpsid");
    system("/usr/sausalito/sbin/system_graphs.pl graph weekly $vpsid");
    system("/usr/sausalito/sbin/system_graphs.pl graph monthly $vpsid");
    system("/usr/sausalito/sbin/system_graphs.pl graph yearly $vpsid");
    $rrd_images = "/usr/sausalito/ui/web/base/traffic/vpsimages/" . $vpsid . "/" . "*.png";
    system("/bin/chmod 644 $rrd_images");
}

# We need to say 'SUCCESS' or CCE will bitch:
$cce->bye('SUCCESS');
exit(0);

# 
# Copyright (c) 2016 Michael Stauber, SOLARSPEED.NET
# All Rights Reserved.
# 
# 1. Redistributions of source code must retain the above copyright 
#         notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright 
#         notice, this list of conditions and the following disclaimer in 
#         the documentation and/or other materials provided with the 
#         distribution.
# 
# 3. Neither the name of the copyright holder nor the names of its 
#         contributors may be used to endorse or promote products derived 
#         from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
# 
# You acknowledge that this software is not designed or intended for 
# use in the design, construction, operation or maintenance of any 
# nuclear facility.
# 